Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp	(revision 1354)
@@ -22,10 +22,6 @@
     if(!comm.is_ep && comm.mpi_comm)
     {
-      ::MPI_Allgather(const_cast<void*>(sendbuf), sendcount, static_cast< ::MPI_Datatype>(sendtype), recvbuf, recvcount, static_cast< ::MPI_Datatype>(recvtype),
-                      static_cast< ::MPI_Comm>(comm.mpi_comm));
-      return 0;
+      return ::MPI_Allgather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
     }
-
-    if(!comm.mpi_comm) return 0;
 
     assert(sendcount == recvcount);
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1354)
@@ -22,6 +22,5 @@
     if(!comm.is_ep && comm.mpi_comm)
     {
-      ::MPI_Allgatherv(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcounts, displs, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
-      return 0;
+      return ::MPI_Allgatherv(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcounts, displs, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
     }
 
@@ -80,5 +79,5 @@
 
       int local_sendcount = std::accumulate(local_recvcounts.begin(), local_recvcounts.end(), 0);
-      MPI_Allgather(&local_sendcount, 1, MPI_INT, mpi_recvcounts.data(), 1, MPI_INT, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allgather(&local_sendcount, 1, to_mpi_type(MPI_INT), mpi_recvcounts.data(), 1, to_mpi_type(MPI_INT), to_mpi_comm(comm.mpi_comm));
 
       for(int i=1; i<mpi_size; i++)
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp	(revision 1354)
@@ -38,5 +38,5 @@
     ::MPI_Aint datasize, lb;
 
-    ::MPI_Type_get_extent(static_cast< ::MPI_Datatype>(datatype), &lb, &datasize);
+    ::MPI_Type_get_extent(to_mpi_type(datatype), &lb, &datasize);
 
     bool is_master = ep_rank_loc==0;
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1354)
@@ -19,5 +19,5 @@
 
     ::MPI_Aint datasize, llb;
-    ::MPI_Type_get_extent(static_cast< ::MPI_Datatype>(sendtype), &llb, &datasize);
+    ::MPI_Type_get_extent(to_mpi_type(sendtype), &llb, &datasize);
 
     int count = sendcount;
@@ -34,6 +34,4 @@
 
     MPI_Gather(sendbuf, count*ep_size, sendtype, tmp_recvbuf, count*ep_size, recvtype, 0, comm);
-
-    
     
     // reorder tmp_buf
@@ -46,6 +44,4 @@
       for(int j=0; j<ep_size; j++)
       {
-        //printf("tmp_recv[%d] = tmp_send[%d]\n", i*ep_size*count + j*count, j*ep_size*count + i*count);
-
         memcpy(tmp_sendbuf + j*ep_size*count*datasize + i*count*datasize, tmp_recvbuf + i*ep_size*count*datasize + j*count*datasize, count*datasize);
       }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp	(revision 1354)
@@ -2,4 +2,5 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
 namespace ep_lib
@@ -18,5 +19,5 @@
       if(ep_rank_loc == 0)
       {
-        ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+        ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
 
         ::MPI_Barrier(mpi_comm);
@@ -27,7 +28,7 @@
       return 0;
     }
-    else if(comm.mpi_comm != static_cast< ::MPI_Comm>(MPI_COMM_NULL.mpi_comm))
+    else if(comm.mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
     {
-      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
       ::MPI_Barrier(mpi_comm);
       return 0;
@@ -47,5 +48,5 @@
     if(ep_rank_loc == 0)
     {
-      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.ep_comm_ptr->intercomm->mpi_inter_comm);
+      ::MPI_Comm mpi_comm = to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm);
       ::MPI_Barrier(mpi_comm);
     }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1354)
@@ -31,7 +31,5 @@
     }
 
-//    #pragma omp flush
     MPI_Barrier_local(comm);
-//    #pragma omp flush
 
     if(ep_rank_loc != local_root)
@@ -50,5 +48,5 @@
     {
       #pragma omp single nowait
-      ::MPI_Bcast(buffer, count, static_cast< ::MPI_Datatype>(datatype), root, static_cast< ::MPI_Comm>(comm.mpi_comm));
+      ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root, to_mpi_comm(comm.mpi_comm));
       return 0;
     }
@@ -62,5 +60,4 @@
     int root_ep_rank_loc = comm.rank_map->at(root).first;
 
-    // printf("root_mpi_rank = %d\n", root_mpi_rank);    
 
     if((ep_rank_loc==0 && mpi_rank != root_mpi_rank ) || ep_rank == root)
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1354)
@@ -9,8 +9,7 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
 using namespace std;
-
-
 
 namespace ep_lib {
@@ -26,15 +25,169 @@
     \param [out] out_comm_hdls Handles of EP communicators.
   */
-  #ifdef _intelmpi
-  int MPI_Comm_create_endpoints(int base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
+  // #ifdef _intelmpi
+  // int MPI_Comm_create_endpoints(int base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
+  // {
+  //   int base_rank;
+  //   int base_size;
+
+  //   ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
+
+  //   ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
+  //   ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
+		// 							  // parent_comm can also be endpoints communicators
+
+  //   std::vector<int> recv_num_ep(base_size);
+
+  //   out_comm_hdls = new MPI_Comm[num_ep];
+
+  //   for (int idx = 0; idx < num_ep; ++idx)
+  //   {
+  //     out_comm_hdls[idx].is_ep = true;
+  //     out_comm_hdls[idx].is_intercomm = false;
+  //     out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
+  //     out_comm_hdls[idx].mpi_comm = base_comm_ptr;
+  //     out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
+  //     out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
+  //   }
+
+  //   ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype>(MPI_INT), &recv_num_ep[0], 1, static_cast< ::MPI_Datatype>(MPI_INT), mpi_base_comm);
+
+
+  //   int sum = 0;  // representing total ep number of process with smaller rank
+  //   for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
+
+  //   int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
+
+  //   out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
+
+  //   out_comm_hdls[0].my_buffer = new BUFFER;
+
+  //   out_comm_hdls[0].rank_map = new RANK_MAP;
+  //   out_comm_hdls[0].rank_map->resize(ep_size);
+
+
+  //   for (int i = 1; i < num_ep; i++)
+  //   {
+  //     out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
+  //     out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
+  //     out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
+  //   }
+
+
+  //   for (int i = 0; i < num_ep; i++)
+  //   {
+  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
+  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
+  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
+
+  //     out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
+  //   }
+
+
+  //   int ind = 0;
+
+  //   for(int i=0; i<base_size; i++)
+  //   {
+  //     for(int j=0; j<recv_num_ep[i]; j++)
+  //     {
+  //       out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
+  //       ind++;
+  //     }
+  //   }
+
+
+
+  //   return 0;
+
+  // } //MPI_Comm_create_endpoints
+
+  // #elif _openmpi
+  // int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
+  // {
+
+  //   int base_rank;
+  //   int base_size;
+
+  //   ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
+
+  //   ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
+  //   ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
+  //                                                // parent_comm can also be endpoints communicators ?
+  //   std::vector<int> recv_num_ep(base_size);
+
+  //   out_comm_hdls = new MPI_Comm[num_ep];
+
+  //   for (int idx = 0; idx < num_ep; ++idx)
+  //   {
+  //     out_comm_hdls[idx].is_ep = true;
+  //     out_comm_hdls[idx].is_intercomm = false;
+  //     out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
+  //     out_comm_hdls[idx].mpi_comm = base_comm_ptr;
+  //     out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
+  //     out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
+  //   }
+
+  //   ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype> (MPI_INT), 
+  //                  &recv_num_ep[0], 1, static_cast< ::MPI_Datatype> (MPI_INT), mpi_base_comm);
+
+  //   int sum = 0;  // representing total ep number of process with smaller rank
+  //   for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
+
+  //   int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
+
+  //   out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
+  //   out_comm_hdls[0].my_buffer = new BUFFER;
+
+  //   out_comm_hdls[0].rank_map = new RANK_MAP;
+  //   out_comm_hdls[0].rank_map->resize(ep_size);
+
+
+  //   for (int i = 1; i < num_ep; i++)
+  //   {
+  //     out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
+  //     out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
+  //     out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
+  //   }
+
+
+  //   for (int i = 0; i < num_ep; i++)
+  //   {
+  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
+  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
+  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
+
+  //     out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
+  //   }
+
+
+  //   int ind = 0;
+
+  //   for(int i=0; i<base_size; i++)
+  //   {
+  //     for(int j=0; j<recv_num_ep[i]; j++)
+  //     {
+  //       out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
+  //       ind++;
+  //     }
+  //   }
+
+  //   return 0;
+
+  // } //MPI_Comm_create_endpoints
+
+  // #endif
+  
+  
+  int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
   {
+
     int base_rank;
     int base_size;
-
-    ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
+    
+    ::MPI_Comm mpi_base_comm = to_mpi_comm(base_comm_ptr);
 
     ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
     ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
-									  // parent_comm can also be endpoints communicators
+                    // parent_comm can also be endpoints communicators
 
     std::vector<int> recv_num_ep(base_size);
@@ -52,5 +205,5 @@
     }
 
-    ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype>(MPI_INT), &recv_num_ep[0], 1, static_cast< ::MPI_Datatype>(MPI_INT), mpi_base_comm);
+    ::MPI_Allgather(&num_ep, 1, to_mpi_type(MPI_INT), &recv_num_ep[0], 1, to_mpi_type(MPI_INT), mpi_base_comm);
 
 
@@ -61,5 +214,4 @@
 
     out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
-
     out_comm_hdls[0].my_buffer = new BUFFER;
 
@@ -97,164 +249,8 @@
     }
 
-
-
     return 0;
 
   } //MPI_Comm_create_endpoints
 
-  #elif _openmpi
-  int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
-  {
-
-    int base_rank;
-    int base_size;
-
-    ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
-
-    ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
-    ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
-                                                 // parent_comm can also be endpoints communicators ?
-    std::vector<int> recv_num_ep(base_size);
-
-    out_comm_hdls = new MPI_Comm[num_ep];
-
-    for (int idx = 0; idx < num_ep; ++idx)
-    {
-      out_comm_hdls[idx].is_ep = true;
-      out_comm_hdls[idx].is_intercomm = false;
-      out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
-      out_comm_hdls[idx].mpi_comm = base_comm_ptr;
-      out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
-      out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
-    }
-
-    ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype> (MPI_INT), 
-                   &recv_num_ep[0], 1, static_cast< ::MPI_Datatype> (MPI_INT), mpi_base_comm);
-
-    int sum = 0;  // representing total ep number of process with smaller rank
-    for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
-
-    int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
-
-    out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
-    out_comm_hdls[0].my_buffer = new BUFFER;
-
-    out_comm_hdls[0].rank_map = new RANK_MAP;
-    out_comm_hdls[0].rank_map->resize(ep_size);
-
-
-    for (int i = 1; i < num_ep; i++)
-    {
-      out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
-      out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
-      out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
-    }
-
-
-    for (int i = 0; i < num_ep; i++)
-    {
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
-
-      out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
-    }
-
-
-    int ind = 0;
-
-    for(int i=0; i<base_size; i++)
-    {
-      for(int j=0; j<recv_num_ep[i]; j++)
-      {
-        out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
-        ind++;
-      }
-    }
-
-    return 0;
-
-  } //MPI_Comm_create_endpoints
-
-  #endif
-  
-  
-  int MPI_Comm_create_endpoints(MPI_Comm base_comm, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
-  {
-
-    int base_rank;
-    int base_size;
-    
-    assert(!base_comm.is_ep);
-
-    ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm.mpi_comm);
-
-    ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
-    ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
-                    // parent_comm can also be endpoints communicators
-
-    std::vector<int> recv_num_ep(base_size);
-
-    out_comm_hdls = new MPI_Comm[num_ep];
-
-    for (int idx = 0; idx < num_ep; ++idx)
-    {
-      out_comm_hdls[idx].is_ep = true;
-      out_comm_hdls[idx].is_intercomm = false;
-      out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
-      out_comm_hdls[idx].mpi_comm = base_comm.mpi_comm;
-      out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
-      out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
-    }
-
-    ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype> (MPI_INT), 
-                &recv_num_ep[0], 1, static_cast< ::MPI_Datatype> (MPI_INT), mpi_base_comm);
-
-
-    int sum = 0;  // representing total ep number of process with smaller rank
-    for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
-
-    int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
-
-    out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
-    out_comm_hdls[0].my_buffer = new BUFFER;
-
-    out_comm_hdls[0].rank_map = new RANK_MAP;
-    out_comm_hdls[0].rank_map->resize(ep_size);
-
-
-    for (int i = 1; i < num_ep; i++)
-    {
-      out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
-      out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
-      out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
-    }
-
-
-    for (int i = 0; i < num_ep; i++)
-    {
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
-
-      out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
-    }
-
-
-    int ind = 0;
-
-    for(int i=0; i<base_size; i++)
-    {
-      for(int j=0; j<recv_num_ep[i]; j++)
-      {
-        out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
-        ind++;
-      }
-    }
-
-    return 0;
-
-  } //MPI_Comm_create_endpoints
-
 
 } //namespace ep_lib
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.cpp	(revision 1354)
@@ -99,6 +99,6 @@
 ep_lib::MPI_Op MPI_MIN = MPI_MIN_STD;
 
-ep_lib::MPI_Comm MPI_COMM_WORLD(MPI_COMM_WORLD_STD);
-ep_lib::MPI_Comm MPI_COMM_NULL(MPI_COMM_NULL_STD);
+ep_lib::MPI_Comm MPI_COMM_WORLD(&MPI_COMM_WORLD_STD);
+ep_lib::MPI_Comm MPI_COMM_NULL(&MPI_COMM_NULL_STD);
 
 ep_lib::MPI_Request MPI_REQUEST_NULL(MPI_REQUEST_NULL_STD);
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_dup.cpp	(revision 1354)
@@ -2,4 +2,5 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
 namespace ep_lib
@@ -14,9 +15,9 @@
       newcomm->is_ep = comm.is_ep;
 
-      ::MPI_Comm input = static_cast< ::MPI_Comm>(comm.mpi_comm);
-      ::MPI_Comm output;
+      ::MPI_Comm input = to_mpi_comm(comm.mpi_comm);
+      ::MPI_Comm *output = new ::MPI_Comm;
 
       
-      ::MPI_Comm_dup(input, &output);
+      ::MPI_Comm_dup(input, output);
 
       newcomm->mpi_comm = output;
@@ -28,5 +29,5 @@
 
     // for intracomm
-    if(comm.mpi_comm == static_cast< ::MPI_Comm >(MPI_COMM_NULL.mpi_comm)) return 0;
+    if(comm.mpi_comm == static_cast< ::MPI_Comm* >(MPI_COMM_NULL.mpi_comm)) return 0;
 
 
@@ -39,9 +40,9 @@
       MPI_Info info;
       MPI_Comm *out_comm;
-      ::MPI_Comm mpi_dup;
+      ::MPI_Comm *mpi_dup = new ::MPI_Comm;
 
-      ::MPI_Comm in_comm = static_cast< ::MPI_Comm>(comm.mpi_comm);
+      ::MPI_Comm in_comm = to_mpi_comm(comm.mpi_comm);
 
-      ::MPI_Comm_dup(in_comm, &mpi_dup);
+      ::MPI_Comm_dup(in_comm, mpi_dup);
 
       MPI_Comm_create_endpoints(mpi_dup, num_ep, info, out_comm);
@@ -59,5 +60,5 @@
   {
     
-    if(comm.mpi_comm == static_cast< ::MPI_Comm >(MPI_COMM_NULL.mpi_comm)) return 0;
+    if(comm.mpi_comm == static_cast< ::MPI_Comm* >(MPI_COMM_NULL.mpi_comm)) return 0;
 
     int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
@@ -69,15 +70,15 @@
       MPI_Info info;
       MPI_Comm *out_comm;
-      ::MPI_Comm mpi_dup;
+      ::MPI_Comm *mpi_dup = new ::MPI_Comm;
 
-      ::MPI_Comm in_comm = static_cast< ::MPI_Comm>(comm.mpi_comm);
+      ::MPI_Comm in_comm = to_mpi_comm(comm.mpi_comm);
 
-      ::MPI_Comm_dup(in_comm, &mpi_dup);
+      ::MPI_Comm_dup(in_comm, mpi_dup);
 
       MPI_Comm_create_endpoints(mpi_dup, num_ep, info, out_comm);
 
-      ::MPI_Comm mpi_inter;
+      ::MPI_Comm *mpi_inter = new ::MPI_Comm;
 
-      ::MPI_Comm_dup(static_cast< ::MPI_Comm>(comm.ep_comm_ptr->intercomm->mpi_inter_comm), &mpi_inter);
+      ::MPI_Comm_dup(to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm), mpi_inter);
       
       for(int i=0; i<num_ep; i++)
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_finalize.cpp	(revision 1354)
@@ -2,5 +2,5 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
-
+#include "ep_mpi.hpp"
 
 namespace ep_lib
@@ -26,5 +26,5 @@
     if(id == 0)
     {
-      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm >(comm.mpi_comm);
+      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
       ::MPI_Abort(mpi_comm, errorcode);
     }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_fortran.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_fortran.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_fortran.cpp	(revision 1354)
@@ -5,8 +5,9 @@
 #include <utility>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
-#ifdef _openmpi
-//#undef MPI_Fint
-#endif
+// #ifdef _openmpi
+// //#undef MPI_Fint
+// #endif
 
 namespace ep_lib
@@ -18,7 +19,7 @@
     int fint;
     #ifdef _intelmpi
-    fint = (::MPI_Fint)(comm.mpi_comm);
+    fint = (::MPI_Fint)(to_mpi_comm(comm.mpi_comm));
     #elif _openmpi
-    fint = ::MPI_Comm_c2f(static_cast< ::MPI_Comm>(comm.mpi_comm));
+    fint = ::MPI_Comm_c2f(to_mpi_comm(comm.mpi_comm));
     #endif
     
@@ -62,8 +63,9 @@
     ::MPI_Comm base_comm = ::MPI_Comm_f2c(comm);
     #elif _intelmpi
-    ::MPI_Comm base_comm = (::MPI_Comm)(comm);
+    ::MPI_Comm *base_comm = new ::MPI_Comm;
+    *base_comm = (::MPI_Comm)(comm);
     #endif
 
-    if(base_comm != static_cast< ::MPI_Comm>(MPI_COMM_NULL.mpi_comm))
+    if(base_comm != static_cast< ::MPI_Comm* >(MPI_COMM_NULL.mpi_comm))
     {
       if(omp_get_thread_num() == 0)
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_free.cpp	(revision 1354)
@@ -2,4 +2,5 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
 namespace ep_lib
@@ -11,7 +12,7 @@
     if(! comm->is_ep)
     {
-      if(comm->mpi_comm != static_cast< ::MPI_Comm>(MPI_COMM_NULL.mpi_comm))
+      if(comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
       {
-        ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm>(comm->mpi_comm);
+        ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
 
         ::MPI_Comm_free(&mpi_comm);
@@ -68,8 +69,8 @@
         }
 
-        if(  comm->mpi_comm != static_cast< ::MPI_Comm>(MPI_COMM_NULL.mpi_comm) 
-          && comm->mpi_comm != static_cast< ::MPI_Comm>(MPI_COMM_WORLD.mpi_comm))
+        if(  comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm) 
+          && comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_WORLD.mpi_comm))
         {
-          ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm>(comm->mpi_comm);
+          ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
           ::MPI_Comm_free(&mpi_comm);
           Debug("mpi_comm freed\n");
@@ -134,7 +135,7 @@
       }
 
-      if(comm->mpi_comm != static_cast< ::MPI_Comm>(MPI_COMM_NULL.mpi_comm))
+      if(comm->mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
       {
-        ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm>(comm->mpi_comm);
+        ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
         ::MPI_Comm_free(&mpi_comm);
         Debug("mpi_comm freed\n");
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_gatherv.cpp	(revision 1354)
@@ -26,6 +26,4 @@
     int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
 
-    //if(ep_rank_loc == local_root) printf("local_gatherv : recvcounts = %d %d\n\n", recvcounts[0], recvcounts[1]);
-    //if(ep_rank_loc == local_root) printf("local_gatherv : displs = %d %d\n\n", displs[0], displs[1]);
 
     #pragma omp critical (_gatherv)
@@ -50,7 +48,6 @@
     if(!comm.is_ep)
     {
-      ::MPI_Gatherv(const_cast<void*>(sendbuf), sendcount, static_cast< ::MPI_Datatype>(sendtype), recvbuf, const_cast<int*>(input_recvcounts), const_cast<int*>(input_displs),
-                    static_cast< ::MPI_Datatype>(recvtype), root, static_cast< ::MPI_Comm>(comm.mpi_comm));
-      return 0;
+      return ::MPI_Gatherv(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, const_cast<int*>(input_recvcounts), const_cast<int*>(input_displs),
+                    to_mpi_type(recvtype), root, to_mpi_comm(comm.mpi_comm));
     }
 
@@ -114,5 +111,4 @@
     else                          MPI_Gatherv_local(sendbuf, sendcount, sendtype, local_recvbuf, local_recvcounts.data(), local_displs.data(), 0, comm);
 
-    //if(is_master) printf("local_recvbuf = %d %d %d %d\n", static_cast<int*>(local_recvbuf)[0], static_cast<int*>(local_recvbuf)[1], static_cast<int*>(local_recvbuf)[2], static_cast<int*>(local_recvbuf)[3]);
 
     void* tmp_recvbuf;
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp	(revision 1347)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_intercomm.cpp	(revision 1354)
@@ -2,4 +2,5 @@
 #include <mpi.h>
 #include "ep_declaration.hpp"
+#include "ep_mpi.hpp"
 
 using namespace std;
@@ -39,19 +40,16 @@
       MPI_Comm_rank(peer_comm, &leader_ranks[2]);
 
-      //printf("leader_ranks = %d, %d, %d\n", leader_ranks[0], leader_ranks[1], leader_ranks[2]);
       MPI_Request request[2];
       MPI_Status status[2];
 
-      MPI_Isend(&leader_ranks[0], 3, static_cast< ::MPI_Datatype>(MPI_INT), remote_leader, tag, peer_comm, &request[0]);
-      MPI_Irecv(&leader_ranks[3], 3, static_cast< ::MPI_Datatype>(MPI_INT), remote_leader, tag, peer_comm, &request[1]);
+      MPI_Isend(&leader_ranks[0], 3, MPI_INT, remote_leader, tag, peer_comm, &request[0]);
+      MPI_Irecv(&leader_ranks[3], 3, MPI_INT, remote_leader, tag, peer_comm, &request[1]);
 
       MPI_Waitall(2, request, status);
 
-      //MPI_Send(&leader_ranks[0], 3, static_cast< ::MPI_Datatype>(MPI_INT), remote_leader, tag, peer_comm);
-      //MPI_Recv(&leader_ranks[3], 3, static_cast< ::MPI_Datatype>(MPI_INT), remote_leader, tag, peer_comm, &status[1]);
     }
 
 
-    MPI_Bcast(leader_ranks, 6, static_cast< ::MPI_Datatype>(MPI_INT), local_leader, local_comm);
+    MPI_Bcast(leader_ranks, 6, MPI_INT, local_leader, local_comm);
 
     
@@ -132,6 +130,6 @@
             new_tag_in_world = TAG++;
           }
-          MPI_Bcast(&new_tag_in_world, 1, static_cast< ::MPI_Datatype> (MPI_INT), new_local_leader, local_comm);
-          if(ep_rank == local_leader) MPI_Send(&new_tag_in_world, 1, static_cast< ::MPI_Datatype> (MPI_INT), remote_leader, tag, peer_comm);
+          MPI_Bcast(&new_tag_in_world, 1, MPI_INT, new_local_leader, local_comm);
+          if(ep_rank == local_leader) MPI_Send(&new_tag_in_world, 1, MPI_INT, remote_leader, tag, peer_comm);
         }
         else
@@ -140,7 +138,7 @@
           {
             MPI_Status status;
-            MPI_Recv(&new_tag_in_world, 1, static_cast< ::MPI_Datatype> (MPI_INT), remote_leader, tag, peer_comm, &status);
-          }
-          MPI_Bcast(&new_tag_in_world, 1, static_cast< ::MPI_Datatype> (MPI_INT), new_local_leader, local_comm);
+            MPI_Recv(&new_tag_in_world, 1, MPI_INT, remote_leader, tag, peer_comm, &status);
+          }
+          MPI_Bcast(&new_tag_in_world, 1, MPI_INT, new_local_leader, local_comm);
         }
 
@@ -148,8 +146,8 @@
         if(ep_rank == new_local_leader)
         {
-          ::MPI_Comm_rank(static_cast< ::MPI_Comm >(MPI_COMM_WORLD.mpi_comm), &leader_in_world[0]);
-        }
-
-        MPI_Bcast(&leader_in_world[0], 1, static_cast< ::MPI_Datatype> (MPI_INT), new_local_leader, local_comm);
+          ::MPI_Comm_rank(to_mpi_comm(MPI_COMM_WORLD.mpi_comm), &leader_in_world[0]);
+        }
+
+        MPI_Bcast(&leader_in_world[0], 1, MPI_INT, new_local_leader, local_comm);
 
 
@@ -159,6 +157,6 @@
           MPI_Status status[2];
 
-          MPI_Isend(&leader_in_world[0], 1, static_cast< ::MPI_Datatype> (MPI_INT), remote_leader, tag, peer_comm, &request[0]);
-          MPI_Irecv(&leader_in_world[1], 1, static_cast< ::MPI_Datatype> (MPI_INT), remote_leader, tag, peer_comm, &request[1]);
+          MPI_Isend(&leader_in_world[0], 1, MPI_INT, remote_leader, tag, peer_comm, &request[0]);
+          MPI_Irecv(&leader_in_world[1], 1, MPI_INT, remote_leader, tag, peer_comm, &request[1]);
 
           MPI_Waitall(2, request, status);
@@ -171,5 +169,5 @@
         if(ep_rank == local_leader) Debug("calling MPI_Intercomm_create_from_world\n");
 
-        return MPI_Intercomm_create_from_world(local_comm, new_local_leader, static_cast< ::MPI_Comm >(MPI_COMM_WORLD.mpi_comm), leader_in_world[1], new_tag_in_world, newintercomm);
+        return MPI_Intercomm_create_from_world(local_comm, new_local_leader, MPI_COMM_WORLD.mpi_comm, leader_in_world[1], new_tag_in_world, newintercomm);
         
       }
@@ -190,7 +188,7 @@
       return 0;
     } 
-    else if(comm.mpi_comm != static_cast< ::MPI_Comm>(MPI_COMM_NULL.mpi_comm))
-    {
-      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+    else if(comm.mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
+    {
+      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
       
       ::MPI_Comm_test_inter(mpi_comm, flag);
